unit Unit1;
{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls;

type
  { TForm1 }
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    procedure ButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PBPaint(Sender: TObject);
    procedure PanelMouseEnter(Sender: TObject);
    procedure PanelMouseLeave(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.ButtonClick(Sender: TObject);
begin
  ShowMessage('Button '+intToStr(TButton(Sender).Tag)+' clicked!');
end;

procedure TForm1.FormCreate(Sender: TObject);
const cCount = 16;
var i: Integer;
    aPanel: TPanel;
    aLabel: TLabel;
    aPB: TPaintBox;
    aButton: TButton;
begin
  for i:=0 to cCount-1 do
    begin
      aPanel:=TPanel.Create(Form1);
      aPanel.AnchorParallel(akLeft, 0, ScrollBox1);
      aPanel.AnchorParallel(akRight, 0, ScrollBox1);
      aPanel.Top:=i*48;
      aPanel.Height:=48;
      aPanel.OnMouseEnter:=@PanelMouseEnter;
      aPanel.OnMouseLeave:=@PanelMouseLeave;
      aPanel.Parent:=ScrollBox1;

      aButton:=TButton.Create(Form1);
      aButton.Anchors:=[akRight, akTop];
      aButton.AnchorParallel(akRight, 8, aPanel);
      aButton.AnchorVerticalCenterTo(aPanel);
      aButton.Caption:='Button '+intToStr(i);
      aButton.Tag:=i;
      aButton.OnClick:=@ButtonClick;
      aButton.Parent:=aPanel;

      aPB:=TPaintBox.Create(Form1);
      aPB.AnchorParallel(akLeft, 8, aPanel);
      aPB.AnchorVerticalCenterTo(aPanel);
      aPB.Height:=40;
      aPB.Width:=40;
      aPB.Tag:=i;
      aPB.OnPaint:=@PBPaint;
      aPB.Parent:=aPanel;

      aLabel:=TLabel.Create(Form1);
      aLabel.AnchorToCompanion(akLeft, 8, aPB);
      aLabel.AnchorVerticalCenterTo(aPanel);
      aLabel.Caption:='Label '+intToStr(i);
      aLabel.Parent:=aPanel;
    end;
end;

procedure TForm1.PBPaint(Sender: TObject);
begin
  with TPaintBox(Sender) do
    begin
      Canvas.Brush.Color:=12*Tag+((15-Tag) shl 20);
      Canvas.FillRect(0, 0, Width, Height);
    end;
end;

procedure TForm1.PanelMouseEnter(Sender: TObject);
begin
  TPanel(Sender).Color:=clHighlight;
end;

procedure TForm1.PanelMouseLeave(Sender: TObject);
begin
  TPanel(Sender).Color:=clDefault;
end;

end.

